<?php
/**
 * InlineResponse20061ContentTickets
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20061ContentTickets Class Doc Comment
 *
 * @category Class
 * @description object containing a found ticket with all associated infos
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20061ContentTickets implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_61_content_tickets';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'string',
        'title' => 'string',
        'content' => 'string',
        'statusId' => 'int',
        'companyId' => 'int',
        'assignedToEmployeeId' => 'int',
        'assignedToDepartmentId' => 'int',
        'extTicketId' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'title' => null,
        'content' => null,
        'statusId' => null,
        'companyId' => null,
        'assignedToEmployeeId' => null,
        'assignedToDepartmentId' => null,
        'extTicketId' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'title' => 'title',
        'content' => 'content',
        'statusId' => 'statusId',
        'companyId' => 'companyId',
        'assignedToEmployeeId' => 'assignedToEmployeeId',
        'assignedToDepartmentId' => 'assignedToDepartmentId',
        'extTicketId' => 'extTicketId'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'title' => 'setTitle',
        'content' => 'setContent',
        'statusId' => 'setStatusId',
        'companyId' => 'setCompanyId',
        'assignedToEmployeeId' => 'setAssignedToEmployeeId',
        'assignedToDepartmentId' => 'setAssignedToDepartmentId',
        'extTicketId' => 'setExtTicketId'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'title' => 'getTitle',
        'content' => 'getContent',
        'statusId' => 'getStatusId',
        'companyId' => 'getCompanyId',
        'assignedToEmployeeId' => 'getAssignedToEmployeeId',
        'assignedToDepartmentId' => 'getAssignedToDepartmentId',
        'extTicketId' => 'getExtTicketId'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['title'] = $data['title'] ?? null;
        $this->container['content'] = $data['content'] ?? null;
        $this->container['statusId'] = $data['statusId'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['assignedToEmployeeId'] = $data['assignedToEmployeeId'] ?? null;
        $this->container['assignedToDepartmentId'] = $data['assignedToDepartmentId'] ?? null;
        $this->container['extTicketId'] = $data['extTicketId'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return string|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string|null $id id of the ticket
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets title
     *
     * @return string|null
     */
    public function getTitle()
    {
        return $this->container['title'];
    }

    /**
     * Sets title
     *
     * @param string|null $title title of the ticket
     *
     * @return self
     */
    public function setTitle($title)
    {
        $this->container['title'] = $title;

        return $this;
    }

    /**
     * Gets content
     *
     * @return string|null
     */
    public function getContent()
    {
        return $this->container['content'];
    }

    /**
     * Sets content
     *
     * @param string|null $content content of the ticket. This is cut by the number of \"previewContentMaxChars\" as defined in the dearch config
     *
     * @return self
     */
    public function setContent($content)
    {
        $this->container['content'] = $content;

        return $this;
    }

    /**
     * Gets statusId
     *
     * @return int|null
     */
    public function getStatusId()
    {
        return $this->container['statusId'];
    }

    /**
     * Sets statusId
     *
     * @param int|null $statusId status id, name is given in the \"linked entities\"
     *
     * @return self
     */
    public function setStatusId($statusId)
    {
        $this->container['statusId'] = $statusId;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId id of the company, name is given in the \"linked entities\"
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets assignedToEmployeeId
     *
     * @return int|null
     */
    public function getAssignedToEmployeeId()
    {
        return $this->container['assignedToEmployeeId'];
    }

    /**
     * Sets assignedToEmployeeId
     *
     * @param int|null $assignedToEmployeeId assigned to employee id, name is given in the \"linked entities\"
     *
     * @return self
     */
    public function setAssignedToEmployeeId($assignedToEmployeeId)
    {
        $this->container['assignedToEmployeeId'] = $assignedToEmployeeId;

        return $this;
    }

    /**
     * Gets assignedToDepartmentId
     *
     * @return int|null
     */
    public function getAssignedToDepartmentId()
    {
        return $this->container['assignedToDepartmentId'];
    }

    /**
     * Sets assignedToDepartmentId
     *
     * @param int|null $assignedToDepartmentId assigned to department id, name is given in the \"linked entities\"
     *
     * @return self
     */
    public function setAssignedToDepartmentId($assignedToDepartmentId)
    {
        $this->container['assignedToDepartmentId'] = $assignedToDepartmentId;

        return $this;
    }

    /**
     * Gets extTicketId
     *
     * @return string|null
     */
    public function getExtTicketId()
    {
        return $this->container['extTicketId'];
    }

    /**
     * Sets extTicketId
     *
     * @param string|null $extTicketId the external ticket id (if given)
     *
     * @return self
     */
    public function setExtTicketId($extTicketId)
    {
        $this->container['extTicketId'] = $extTicketId;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


